// comment the following line to enable Microsoft C
#define PIC32
#if defined(PIC32)
#include <p32xxxx.h>
	// comment the following line to enable debug output
//#define UART2_IO
#include "db_utils.h"
#else // Microsoft C
#include <stdio.h>
#define DBPRINTF printf
#define DBPUTS(s)
#endif

char *phrase = "The quick brown fox jumps over the lazy dog";

signed char peppers[] = {'p','e','p','p','e','r','s',-5,0};

unsigned short bins[96];

double v[4] = {1.0, 2.0, 3.0, 4.0};

void do_hist(char *str, int len, short bins[96]);
void show_bins(short bins[96]);
double cum_sum(double v[], int len);

int main()
{
	int i, nv, ns;
	printf("peppers = %p\n",peppers);
	nv = strlen(peppers);
	printf("string length %d\n",nv);
	ns = 0;
	for (i=0; i<nv; i++) {
		if (peppers[i]<0) ns++;
	}
	printf("negative bytes: %d\n",ns);
	printf("phrase = %p\n",phrase);
	nv = strlen(phrase);
	printf("bins = %p\n",bins);
	do_hist(phrase,nv,bins);
	show_bins(bins);
	printf("v = %p\n",v);
	nv = sizeof(v) / sizeof(v[0]);
	printf("v length %d\n",nv);
	cum_sum(v,nv);
	for (i=0; i<nv; i++) {
		printf("%g\n",v[i]);
	}
	DBPUTS("Program terminated. Click HALT and then RESET to stop the microcontroller. \n");
	return 0;
}

int strlen(char *str)
{
	int count = 0;
	while (*str++) count++;
	return count;
}

void show_bins(short bins[96])
{
	int i, n;
	unsigned char ch;
	unsigned char str[60];
	unsigned char *cp;
	cp = str;
	for (i=1; i<60; i++) {
		*cp = 0;
		ch = i+32;
		n = bins[i];
		if (n==0) continue;
		*cp++ = ch;
		printf("%c %4d\n",ch,bins[i]);
	}
	printf("characters present:\n%s\n",str);
	n = strlen(str);
	printf("number of characters: %d\n",n);
}

void do_hist(char *str, int len, short bins[96])
{
	int i, n;
	for (i=0; i<96; i++) bins[i] = 0;
	for (i=0; i<len; i++) {
		n = str[i]&0x7F;
		if (n==0) break;
		if (n>96) n -= 32;
		if (n>32) n -= 32;
		else n = 0;
		bins[n]++;
	}
}

double cum_sum(double v[], int len)
{
	int i;
	double sum = v[0];
	for (i=1; i<len; i++) {
		sum += v[i];
		v[i] = sum;
	}
	return sum;
}
